## qemu 10.2.0+ds

=== meson_options.txt ===
# These options do not correspond to a --enable/--disable-* option
# on the configure script command line.  If you add more, list them in
# scripts/meson-buildoptions.py's SKIP_OPTIONS constant too.

option('qemu_suffix', type : 'string', value: 'qemu',
       description: 'Suffix for QEMU data/modules/config directories (can be empty)')
option('docdir', type : 'string', value : 'share/doc',
       description: 'Base directory for documentation installation (can be empty)')
option('qemu_firmwarepath', type : 'array', value : ['share/qemu-firmware'],
       description: 'search PATH for firmware files')
option('pkgversion', type : 'string', value : '',
       description: 'use specified string as sub-version of the package')
option('smbd', type : 'string', value : '',
       description: 'Path to smbd for slirp networking')
option('iasl', type : 'string', value : '',
       description: 'Path to ACPI disassembler')
option('tls_priority', type : 'string', value : 'NORMAL',
       description: 'Default TLS protocol/cipher priority string')
option('default_devices', type : 'boolean', value : true,
       description: 'Include a default selection of devices in emulators')
option('audio_drv_list', type: 'array', value: ['default'],
       choices: ['alsa', 'coreaudio', 'default', 'dsound', 'jack', 'oss', 'pa', 'pipewire', 'sdl', 'sndio'],
       description: 'Set audio driver list')
option('block_drv_rw_whitelist', type : 'string', value : '',
       description: 'set block driver read-write whitelist (by default affects only QEMU, not tools like qemu-img)')
option('block_drv_ro_whitelist', type : 'string', value : '',
       description: 'set block driver read-only whitelist (by default affects only QEMU, not tools like qemu-img)')
option('interp_prefix', type : 'string', value : '/usr/gnemul/qemu-%M',
       description: 'where to find shared libraries etc., use %M for cpu name')
option('rtsig_map', type : 'string', value : 'NULL',
       description: 'default value of QEMU_RTSIG_MAP')
option('fuzzing_engine', type : 'string', value : '',
       description: 'fuzzing engine library for OSS-Fuzz')
option('trace_file', type: 'string', value: 'trace',
       description: 'Trace file prefix for simple backend')
option('coroutine_backend', type: 'combo',
       choices: ['ucontext', 'sigaltstack', 'windows', 'wasm', 'auto'],
       value: 'auto', description: 'coroutine backend to use')
option('gdb', type: 'string', value: '',
       description: 'Path to GDB')

# Everything else can be set via --enable/--disable-* option
# on the configure script command line.  After adding an option
# here make sure to run "make update-buildoptions".

option('docs', type : 'feature', value : 'auto',
       description: 'Documentations build support')
option('fuzzing', type : 'boolean', value: false,
       description: 'build fuzzing targets')
option('gettext', type : 'feature', value : 'auto',
       description: 'Localization of the GTK+ user interface')
option('modules', type : 'feature', value : 'disabled',
       description: 'modules support (non Windows)')
option('module_upgrades', type : 'boolean', value : false,
       description: 'try to load modules from alternate paths for upgrades')
option('install_blobs', type : 'boolean', value : true,
       description: 'install provided firmware blobs')
option('sparse', type : 'feature', value : 'auto',
       description: 'sparse checker')
option('guest_agent', type : 'feature', value : 'auto',
       description: 'Build QEMU Guest Agent')
option('guest_agent_msi', type : 'feature', value : 'auto',
       description: 'Build MSI package for the QEMU Guest Agent')
option('tools', type : 'feature', value : 'auto',
       description: 'build support utilities that come with QEMU')
option('qga_vss', type : 'feature', value: 'auto',
       description: 'build QGA VSS support (broken with MinGW)')

option('malloc_trim', type : 'feature', value : 'auto',
       description: 'enable libc malloc_trim() for memory optimization')
option('malloc', type : 'combo', choices : ['system', 'tcmalloc', 'jemalloc'],
       value: 'system', description: 'choose memory allocator to use')

option('kvm', type: 'feature', value: 'auto',
       description: 'KVM acceleration support')
option('mshv', type: 'feature', value: 'auto',
       description: 'MSHV acceleration support')
option('whpx', type: 'feature', value: 'auto',
       description: 'WHPX acceleration support')
option('hvf', type: 'feature', value: 'auto',
       description: 'HVF acceleration support')
option('nvmm', type: 'feature', value: 'auto',
       description: 'NVMM acceleration support')
option('xen', type: 'feature', value: 'auto',
       description: 'Xen backend support')
option('xen_pci_passthrough', type: 'feature', value: 'auto',
       description: 'Xen PCI passthrough support')
option('tcg', type: 'feature', value: 'enabled',
       description: 'TCG support')
option('plugins', type: 'boolean', value: false,
       description: 'TCG plugins via shared library loading')
option('debug_tcg', type: 'boolean', value: false,
       description: 'TCG debugging')
option('debug_remap', type: 'boolean', value: false,
       description: 'syscall buffer debugging support')
option('tcg_interpreter', type: 'boolean', value: false,
       description: 'TCG with bytecode interpreter (slow)')
option('safe_stack', type: 'boolean', value: false,
       description: 'SafeStack Stack Smash Protection (requires clang/llvm and coroutine backend ucontext)')
option('asan', type: 'boolean', value: false,
       description: 'enable address sanitizer')
option('ubsan', type: 'boolean', value: false,
       description: 'enable undefined behaviour sanitizer')
option('tsan', type: 'boolean', value: false,
       description: 'enable thread sanitizer')
option('stack_protector', type: 'feature', value: 'auto',
       description: 'compiler-provided stack protection')
option('cfi', type: 'boolean', value: false,
       description: 'Control-Flow Integrity (CFI)')
option('cfi_debug', type: 'boolean', value: false,
       description: 'Verbose errors in case of CFI violation')
option('multiprocess', type: 'feature', value: 'auto',
       description: 'Out of process device emulation support')
option('relocatable', type : 'boolean', value : true,
       description: 'toggle relocatable install')
option('vfio_user_server', type: 'feature', value: 'disabled',
       description: 'vfio-user server support')
option('dbus_display', type: 'feature', value: 'auto',
       description: '-display dbus support')
option('tpm', type : 'feature', value : 'auto',
       description: 'TPM support')
option('valgrind', type : 'feature', value: 'auto',
       description: 'valgrind debug support for coroutine stacks')
option('igvm', type: 'feature', value: 'auto',
       description: 'Independent Guest Virtual Machine (IGVM) file support')

# Do not enable it by default even for Mingw32, because it doesn't
# work on Wine.
option('membarrier', type: 'feature', value: 'disabled',
       description: 'membarrier system call (for Linux 4.14+ or Windows')

option('keyring', type: 'feature', value: 'auto',
       description: 'Linux keyring support')
option('libkeyutils', type: 'feature', value: 'auto',
       description: 'Linux keyutils support')

option('af_xdp', type : 'feature', value : 'auto',
       description: 'AF_XDP network backend support')
option('attr', type : 'feature', value : 'auto',
       description: 'attr/xattr support')
option('auth_pam', type : 'feature', value : 'auto',
       description: 'PAM access control')
option('brlapi', type : 'feature', value : 'auto',
       description: 'brlapi character device driver')
option('bzip2', type : 'feature', value : 'auto',
       description: 'bzip2 support for DMG images')
option('cap_ng', type : 'feature', value : 'auto',
       description: 'cap_ng support')
option('blkio', type : 'feature', value : 'auto',
       description: 'libblkio block device driver')
option('bpf', type : 'feature', value : 'auto',
        description: 'eBPF support')
option('cocoa', type : 'feature', value : 'auto',
       description: 'Cocoa user interface (macOS only)')
option('curl', type : 'feature', value : 'auto',
       description: 'CURL block device driver')
option('gio', type : 'feature', value : 'auto',
       description: 'use libgio for D-Bus support')
option('glusterfs', type : 'feature', value : 'auto',
       description: 'Glusterfs block device driver')
option('hv_balloon', type : 'feature', value : 'auto',
       description: 'hv-balloon driver (requires Glib 2.68+ GTree API)')
option('libdw', type : 'feature', value : 'auto',
       description: 'debuginfo support')
option('libiscsi', type : 'feature', value : 'auto',
       description: 'libiscsi userspace initiator')
option('libnfs', type : 'feature', value : 'auto',
       description: 'libnfs block device driver')
option('mpath', type : 'feature', value : 'auto',
       description: 'Multipath persistent reservation passthrough')
option('numa', type : 'feature', value : 'auto',
       description: 'libnuma support')
option('iconv', type : 'feature', value : 'auto',
       description: 'Font glyph conversion support')
option('curses', type : 'feature', value : 'auto',
       description: 'curses UI')
option('libcbor', type : 'feature', value : 'auto',
       description: 'libcbor support')
option('gnutls', type : 'feature', value : 'auto',
       description: 'GNUTLS cryptography support')
option('nettle', type : 'feature', value : 'auto',
       description: 'nettle cryptography support')
option('gcrypt', type : 'feature', value : 'auto',
       description: 'libgcrypt cryptography support')
option('crypto_afalg', type : 'feature', value : 'disabled',
       description: 'Linux AF_ALG crypto backend driver')
option('libdaxctl', type : 'feature', value : 'auto',
       description: 'libdaxctl support')
option('libpmem', type : 'feature', value : 'auto',
       description: 'libpmem support')
option('libssh', type : 'feature', value : 'auto',
       description: 'ssh block device support')
option('libudev', type : 'feature', value : 'auto',
       description: 'Use libudev to enumerate host devices')
option('libusb', type : 'feature', value : 'auto',
       description: 'libusb support for USB passthrough')
option('linux_aio', type : 'feature', value : 'auto',
       description: 'Linux AIO support')
option('linux_io_uring', type : 'feature', value : 'auto',
       description: 'Linux io_uring support')
option('lzfse', type : 'feature', value : 'auto',
       description: 'lzfse support for DMG images')
option('lzo', type : 'feature', value : 'auto',
       description: 'lzo compression support')
option('pvg', type: 'feature', value: 'auto',
       description: 'macOS paravirtualized graphics support')
option('rbd', type : 'feature', value : 'auto',
       description: 'Ceph block device driver')
option('opengl', type : 'feature', value : 'auto',
       description: 'OpenGL support')
option('rdma', type : 'feature', value : 'auto',
       description: 'Enable RDMA-based migration')
option('gtk', type : 'feature', value : 'auto',
       description: 'GTK+ user interface')
option('sdl', type : 'feature', value : 'auto',
       description: 'SDL user interface')
option('sdl_image', type : 'feature', value : 'auto',
       description: 'SDL Image support for icons')
option('seccomp', type : 'feature', value : 'auto',
       description: 'seccomp support')
option('smartcard', type : 'feature', value : 'auto',
       description: 'CA smartcard emulation support')
option('snappy', type : 'feature', value : 'auto',
       description: 'snappy compression support')
option('spice', type : 'feature', value : 'auto',
       description: 'Spice server support')
option('spice_protocol', type : 'feature', value : 'auto',
       description: 'Spice protocol support')
option('u2f', type : 'feature', value : 'auto',

=== debian/changelog ===
qemu (1:10.2.0+ds-2) unstable; urgency=medium

  * two patches to make statically-linked linux-user not depend on nss
    (remove linkage to qemu-sockets.c)
  * 1095935.patch (Closes: #1095935)
  * d/control: qemu-user: mention possibility to sym-link files in
    /usr/share/qemu/binfmt.d/ to /etc/binfmt.d/
  * d/rules: remove workaround for #1019011 for palcode-clipper -
    the bug in gcc has been fixed (in 2022)
  * d/control: better versioned dependencies of qemu modules: use
    qemu-system-common as a syncronisation point instead of qemu-system-any
    (Closes: LP#2127053)
  * d/control: finally de-couple qemu-system-riscv and qemu-system-s390x
    from qemu-system-misc (remove misc:Depends: riscv, s390x)
  * fix-PIRQ-bounds-check-in-xen_physdev_map_pirq-CVE-2026-0665.patch
    (Closes: #1125423, CVE-2026-0665)
  * d/copyright: fix Files/License sections

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 14 Jan 2026 18:22:29 +0300

qemu (1:10.2.0+ds-1) unstable; urgency=medium

  * new upstream release
  * d/gbp.conf: switch to 10.2
  * d/patches: refresh
  * d/control.mk: checked-version: 10.2.0+ds, vdso-version: 1:10.2.0+ds-1~
  * d/copyright: rename u-boot-sam460ex bin following upstream change
  * d/copyright: add pc-bios/npcm[78]xx_bootrom.bin to Files-Excluded
  * d/rules: adjust for u-boot-sam460ex rename, work around build bug,
    provide a compat symlink for now
  * d/control.mk: 32bit mips and powerpc hosts are not supported anymore

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 24 Dec 2025 23:20:44 +0300

=== debian/control ===
# autogenerated file from debian/control-in
Source: qemu
Section: otherosfs
Priority: optional
Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: Michael Tokarev <mjt@tls.msk.ru>
Build-Depends: debhelper-compat (= 13),
 python3-venv:any,
# distlib is needed for pip-25.2+ (forky+), not for trixie or before
 python3-distlib:native | python3-distlib,
 python3:any (>> 3.11),
 meson (>> 1.5.0~), ninja-build,
 flex, bison,
# for :native suffix see #995622
 python3-sphinx:native, python3-sphinx-rtd-theme:native,
# python3-pycotap:native,
Build-Depends-Arch:
# In comments below we also specify (system-specific) arguments
# to qemu's configure script, -- optional features which depend
# on build-dependencies.
# always needed
 pkgconf, libglib2.0-dev, zlib1g-dev,
# target/hexagon/ builds a build-time (ie: native) tool using glib
 pkgconf:native, libglib2.0-dev:native,
# iasl (from acpica-tools) is used only in a single test these days, not for building
# acpica-tools,
# libcapstone is in universe in ubuntu
# --enable-capstone
 libcapstone-dev,
# --enable-linux-aio	linux-any
 libaio-dev            [linux-any],
# libsndio is in universe in ubuntu
# --disable-sndio
# --audio-drv-list=pipewire,pa,alsa,jack,oss,sdl	amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libjack-dev    [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
 libpulse-dev   [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
 libasound2-dev [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
 libpipewire-0.3-dev [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# for virtfs (now in libc6)
# --enable-attr
# --enable-bpf	 amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libbpf-dev	[amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-blkio	amd64 arm64 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc64
 libblkio-dev	       [amd64 arm64 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
# --enable-brlapi	amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libbrlapi-dev         [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-virtfs	amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
# needed for virtfs
# --enable-cap-ng	amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libcap-ng-dev         [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-curl
 libcurl4-gnutls-dev,
# --enable-fdt	 amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libfdt-dev	[amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-fuse		 linux-any
 libfuse3-dev		[linux-any],
# --enable-gnutls
 gnutls-dev,
# --enable-gtk --enable-vte	amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libgtk-3-dev    [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
 libvte-2.91-dev [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-libiscsi
 libiscsi-dev,
# --enable-curses	amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libncurses-dev        [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-virglrenderer	amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libvirglrenderer-dev          [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-opengl	amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libepoxy-dev [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
 libdrm-dev   [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
 libgbm-dev   [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-libnfs
 libnfs-dev,
# --enable-numa	amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libnuma-dev   [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-smartcard	 amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libcacard-dev		[amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-pixman	 amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libpixman-1-dev	[amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-rbd		amd64 arm64 loong64 mips64el ppc64el riscv64 s390x
 librbd-dev            [amd64 arm64 loong64 mips64el ppc64el riscv64 s390x],
# gluster is 64bit-only: #1039604
# --enable-glusterfs	 amd64 arm64 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc64
 libglusterfs-dev	[amd64 arm64 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
# --enable-vnc-sasl	 amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libsasl2-dev		[amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-sdl	amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libsdl2-dev [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-seccomp	amd64 arm64 armel armhf i386 loong64 mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x
 libseccomp-dev        [amd64 arm64 armel armhf i386 loong64 mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x],
# --enable-slirp	 amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libslirp-dev		[amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-spice	 amd64 i386 arm64 armel armhf loong64 mips64el mipsel ppc64el riscv64
 libspice-server-dev	[amd64 i386 arm64 armel armhf loong64 mips64el mipsel ppc64el riscv64],
# --enable-rdma		linux-any
 librdmacm-dev [linux-any], libibverbs-dev [linux-any], libibumad-dev [linux-any],
# --enable-linux-io-uring	linux-any
 liburing-dev                  [linux-any],
# --enable-libusb	amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libusb-1.0-0-dev      [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-usb-redir	amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libusbredirparser-dev [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-libssh
 libssh-dev,
# --enable-zstd
 libzstd-dev,
# vde is debian-only since ubuntu/vde2 is in universe
# --enable-vde	 amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libvdeplug-dev	[amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
 libxen-dev [linux-amd64],
# --enable-nettle	 amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 nettle-dev		[amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# other optional features we enable
# --enable-libudev
# needed for qga?
 libudev-dev [linux-any],
# --enable-vnc	 amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
# --enable-vnc-jpeg	amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libjpeg-dev	[amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-png	 amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
 libpng-dev	[amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64],
# --enable-libpmem	amd64 arm64
 libpmem-dev           [amd64 arm64],
# --enable-kvm		amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64
# --enable-vhost-net	amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64	# is it really linux-specific?
##--enable-lzo todo, for (memory) dumps
##--enable-netmap todo bsd
##--enable-xen-pci-passthrough todo
## auth-pam - for auth for vnc&Co using PAM
#
# the testsuite:
# ipxe-qemu [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64] <!nocheck>,
 seabios (>> 1.17.0-1~) [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64] <!nocheck>,
 qemu-system-data (>> 1:9.0) [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64] <!nocheck !pkg.qemu.omit-system>,
#
# vdso: for linux-user, we need small arch-specific .so files to embed them
#       into linux-user for many architectures.
#    On debian, arch and indep parts are built separately, and cross-compilers
#    to build all vdsos aren't available on all architectures.  So we build a
#    tarball of them in indep build and place it in qemu-system-data.  When
#    building both arch+indep parts in one go, d/rules has magic to always
#    (re)build vdso files and use the result immediately.
#  pkg.qemu.use-upstream-vdso - always use upstream pre-built vdso files,
#    do not embed vdso files into qemu-system-data binary package
#  pkg.qemu.omit-vdso-build-dep - do not Build-Depend-Arch: qemu-system-data for
#    vdso (allows to build and use vdso files with single arch+indep build)
# Ubuntu builds both arch+indep parts (on amd64), so there this is irrelevant.
#    Effectively it always enables pkg.qemu.omit-vdso-build-dep build-profile.
# With each upstream, check if vdso code changed and bump the version:
 qemu-system-data (>> 1:10.2.0+ds-1~) [amd64 arm arm64 armel armhf i386 loong64 mips64 mips64el ppc64 ppc64el riscv64 s390x sparc sparc64]
   <!pkg.qemu.use-upstream-vdso !pkg.qemu.omit-vdso-build-dep !pkg.qemu.omit-user>,
Build-Depends-Indep:
# x86_64 firmware
 gcc-x86-64-linux-gnu,
# compiler used to build i386 firmware
 gcc-i686-linux-gnu,
# pc-bios/*.dts => *.dtb (PPC firmware)
 device-tree-compiler,
 gcc-s390x-linux-gnu,
# qemu-palcode/palcode-clipper
 gcc-alpha-linux-gnu,
# u-boot code
 gcc-powerpc-linux-gnu,
# skiboot firmware, openbios
 gcc-powerpc64-linux-gnu,
# skiboot includes <openssl/something.h>
 libssl-dev,
# openbios
 gcc-sparc64-linux-gnu, fcode-utils, xsltproc,
# hppa-firmware (32 and 64 bit)
 gcc-hppa-linux-gnu, gcc-hppa64-linux-gnu,
 gcc-riscv64-linux-gnu,
# vbootrom/npcm7xx
 gcc-arm-linux-gnueabi, libc6-dev-armel-cross,
# vbootrom/npcm8xx
 gcc-aarch64-linux-gnu, libc6-dev-arm64-cross,
# vdso (configure:probe_target_compiler() needs libc too):
 gcc-arm-linux-gnueabi <!pkg.qemu.use-upstream-vdso>, libc6-dev-armel-cross <!pkg.qemu.use-upstream-vdso>,
 gcc-hppa-linux-gnu <!pkg.qemu.use-upstream-vdso>, libc6-dev-hppa-cross <!pkg.qemu.use-upstream-vdso>,

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

# stop python from generating .pyc caches
export PYTHONDONTWRITEBYTECODE=1

# in order to keep output non-intermixed together, disable parallel building
# of different targets in this d/rules but allow running parallel submakes
.NOTPARALLEL:

# this includes pkg-info.mk and defines VENDOR (debian|ubuntu):
include debian/control.mk

ifeq ($(and ${DEB_HOST_MULTIARCH},${DEB_HOST_ARCH}),)
# Fast version of dpkg/architecture.mk defining all vars in one go
   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
endif

# we build in a sub-subdir so strip that from file paths too
export DEB_CFLAGS_MAINT_APPEND = -ffile-prefix-map=../../=

# Disable LTO on non-amd64 builds, see:
# https://bugs.launchpad.net/ubuntu/+source/qemu/+bug/1921664
# https://issues.redhat.com/browse/RHEL-7385
ifneq ($(DEB_HOST_ARCH),amd64)
  export DEB_BUILD_MAINT_OPTIONS += optimize=-lto
endif

# get CFLAGS LDFLAGS etc (should come after DEB_*MAINT*)
include /usr/share/dpkg/buildflags.mk

# DEB_BUILD_OPTIONS=parallel=N
MAKEFLAGS += $(subst parallel=,-j,$(filter parallel=%,${DEB_BUILD_OPTIONS}))
NUMJOBS := $(lastword 1 $(subst -j,,$(filter -j%,${MAKEFLAGS})))
# verbose build
V := $(if $(filter terse, ${DEB_BUILD_OPTIONS}),,1)

NINJA = ninja $(if $V,-v) -j${NUMJOBS}
MESON = meson

# list of packages we're supposed to build
BUILD_PACKAGES := $(shell dh_listpackages)

enable-system = $(if $(filter qemu-system,${BUILD_PACKAGES}),y)
enable-user = $(if $(filter qemu-user,${BUILD_PACKAGES}),y)

QEMU_XEN = /usr/libexec/xen-qemu-system-i386
PKGVERSION = Debian ${DEB_VERSION}
sysdatadir = /usr/share/qemu
sysdataidir = debian/qemu-system-data${sysdatadir}
libdir = /usr/lib/${DEB_HOST_MULTIARCH}
mandir = /usr/share/man
man1dir = ${mandir}/man1
# remove ipxe for forky, require ipxe-qemu >> 1.21.1+git20220113.fbbdc3926+dfsg-1~ :
FIRMWAREPATH = /usr/share/qemu:/usr/share/seabios:/usr/lib/ipxe/qemu

export cross_prefix_alpha = alpha-linux-gnu-
export cross_prefix_aarch64 = aarch64-linux-gnu-
export cross_prefix_arm = arm-linux-gnueabi-
export cross_prefix_hppa = hppa-linux-gnu-
export cross_prefix_hppa64 = hppa64-linux-gnu-
export cross_prefix_i386 = i686-linux-gnu-
export cross_prefix_loongarch64 = loongarch64-linux-gnu-
export cross_prefix_ppc = powerpc-linux-gnu-
export cross_prefix_ppc64 = powerpc64-linux-gnu-
export cross_prefix_riscv64 = riscv64-linux-gnu-
export cross_prefix_s390x = s390x-linux-gnu-

extra-cflags = ${CFLAGS} ${CPPFLAGS}
extra-ldflags = ${LDFLAGS} -Wl,--as-needed

# we add another set of configure options from debian/control
common_configure_opts = \
	--with-pkgversion="$(PKGVERSION)" \
	--prefix=/usr \
	--sysconfdir=/etc \
	--libdir=${libdir} \
	--libexecdir=/usr/lib/qemu \
	--firmwarepath=${FIRMWAREPATH} \
	--localstatedir=/var \
	--mandir=${mandir} \
	--disable-install-blobs \
	--disable-strip \
	--localstatedir=/var \
	--disable-download \
	--disable-containers \
	--disable-relocatable \
	--disable-docs \
	${empty}
# this disables building of qemu-keymap tool (!)
# qemu-keymap might be helpful for qemu-system -k <lang>
# but is -k flag useful these days?
common_configure_opts += --disable-xkbcommon

# Cross compiling support
ifneq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
common_configure_opts  += --cross-prefix=$(DEB_HOST_GNU_TYPE)-
endif

comma:=,

# system-packages, system-archlist-$pkg, system-alias-$arch, system-kvm
# are defined in d/control.mk

# qemu-system subpackages
define install-all-system
$(foreach p,${system-packages},\
  $(call install-system,qemu-system-$p,${system-archlist-$p}\
  ,$(strip $(foreach a,${system-archlist-$p},$(if $(filter $a ${system-alias-$a},${DEB_HOST_ARCH_CPU}),$a)))))
endef

# install-system qemu-system-$pkg, ${system-archlist-$pkg}, [native-qemu-arch]
# install qemu-arch-list binaries with manpages and aliases into pkg
# install kvm link to qemu-system-${kvm-link} if it is not empty
# fills in qemu:Provides and qemu:archlist substvars
define install-system
# ==== installing $1 ===
dh_installdirs -p $1 usr/bin ${man1dir}
mv -t debian/$1/usr/bin/ $(addprefix debian/tmp/usr/bin/qemu-system-, $2)
$(foreach q, $2,\
 echo ".so man1/qemu-system.1" > debian/$1${man1dir}/qemu-system-$q.1
)
dh_link -p $1 \
 $(foreach q, $2, \
   $(if $(filter $3,${system-kvm}), \
            usr/bin/qemu-system-$3 usr/bin/kvm \
            ${man1dir}/qemu-system-$3.1 ${man1dir}/kvm.1) \
   $(foreach a, ${system-alias-$q}, \
     usr/bin/qemu-system-$q usr/bin/qemu-system-$a \
     ${man1dir}/qemu-system-$q.1 ${man1dir}/qemu-system-$a.1 \
  ))
${# note: older make does not understand line-splitting inside $(functions ..)}
echo 'qemu:Provides=$(if $3,qemu-system-native (=${DEB_VERSION})${comma})\
 $(if $(filter $3,${system-kvm}),qemu-kvm (=${DEB_VERSION})${comma})\
 $(patsubst %,% (=${DEB_VERSION})${comma},$(filter-out $1, $(patsubst %, qemu-system-%, any $2 $(foreach q,$2,${system-alias-$q}))))' \
    | tr _ - >> debian/$1.substvars
echo 'qemu:Conflicts=$(if $(filter $3,${system-kvm}),qemu-kvm)' >> debian/$1.substvars
${# construct list `arch1 arch2 (alias) arch3..' for Description and word-wrap it}
echo 'qemu:archlist=$(foreach q,$2,$q$(if ${system-alias-$q}, (${system-alias-$q})))' \
    | sed -E 's/(.{37,45})\s([^(].{9})/\1\$${Newline}  \2/' >> debian/$1.substvars
dh_installdocs -p $1 --link-doc=qemu-system-common
${# keep empty line at the end }
endef

sysdata-components :=
qemu-builds :=

# several builds of qemu binaries:

##############################################
# main system and tools build
configure-qemu: b/qemu/configured
b/qemu/configured: configure
	rm -rf b/qemu; mkdir -p b/qemu
	cd b/qemu && \
	    ../../configure ${common_configure_opts} \
		--extra-cflags="${extra-cflags}" \
		--extra-ldflags="${extra-ldflags}" \
		--$(if ${enable-system},enable,disable)-system \
		--$(if $(filter qemu-guest-agent,${BUILD_PACKAGES}),enable,disable)-guest-agent \
		--disable-user --disable-linux-user \
		--enable-tools \
		--disable-xen \
		--enable-modules \
		$(if ${enable-system},--enable-module-upgrades) \
		$(shell sh debian/extract-config-opts \
		    $(DEB_HOST_ARCH_OS)-$(DEB_HOST_ARCH) debian/control) \
		${QEMU_CONFIGURE_OPTIONS} || \
	   { tail -n20 config.log meson-logs/meson-log.txt && false; }
	touch $@

build-qemu: b/qemu/built
b/qemu/built: b/qemu/configured
	${NINJA} -C b/qemu
	touch $@

ifeq (,$(findstring nocheck, ${DEB_BUILD_OPTIONS} ${DEB_BUILD_PROFILES}))
ifeq (${enable-system},y)
ifneq (sparc64,${DEB_HOST_ARCH}) # tests are broken on sparc64
build-qemu: b/qemu/tested
endif
endif
endif

test-qemu: b/qemu/tested
b/qemu/tested: b/qemu/built
	# ======== begin testing ========
	rm -rf b/qemu/qemu-bundle
	QEMU_MODULE_DIR=${CURDIR}/b/qemu \
	    ${MESON} test -C b/qemu --suite=block -t2 \
		--num-processes=${NUMJOBS} --no-rebuild --print-errorlogs
	# ========= end testing =========
	touch $@

install-qemu: build-qemu
	DESTDIR=${CURDIR}/debian/tmp \
	    ${NINJA} -C b/qemu install

# remove qtest "accel" modules
	rm -f debian/tmp${libdir}/qemu/accel-qtest-*.so

ifeq (${enable-system},y)

	$(call install-all-system)

ifneq ($(filter ${DEB_HOST_ARCH},amd64 i386),)
# qemu-vmsr-helper is x86-specific
	install -m0755 -D -t debian/qemu-system-common/usr/bin/ \
		debian/tmp/usr/bin/qemu-vmsr-helper
	rm debian/tmp/usr/bin/qemu-vmsr-helper
	install -m0644 -p -D -t debian/qemu-system-common/usr/lib/systemd/system/ \
		contrib/systemd/qemu-vmsr-helper.service \
		contrib/systemd/qemu-vmsr-helper.socket
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)

ifeq (${VENDOR},ubuntu)
ifneq ($(filter ${DEB_HOST_ARCH},amd64 i386),)
# on ubuntu *-spice existed, may be used in libvirt xml and scripts - keep links for compatibility
# The sunset for this will be when Ubuntu-Bionic goes out of support which is expected to happen in 2028
	install -m0644 -p -t debian/qemu-system-x86/usr/bin debian/kvm-spice debian/qemu-system-x86_64-spice

=== debian/watch ===
version=4

opts=\
dversionmangle=auto,\
repacksuffix=+ds,\
pgpsigurlmangle=s/$/.sig/,\
compression=xz \
  https://download.qemu.org/ qemu-(10\.2\.\d+)\.tar\.xz

## qemu 10.2.1%2Bds

=== roms/u-boot-sam460ex/tools/updater/Makefile ===
#
# (C) Copyright 2000-2006
# Wolfgang Denk, DENX Software Engineering, wd@denx.de.
#
# See file CREDITS for list of people who contributed to this
# project.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307 USA
#

LOAD_ADDR = 0x1000000

include $(TOPDIR)/config.mk
include $(TOPDIR)/include/updater-config.mk

PROG		= $(obj)updater
IMAGE		= $(obj)updater.image

#respect the objects order... padding before dummy, dummy as last
COBJS		= update.o flash.o flash_hw.o utils.o cmd_flash.o string.o ctype.o dummy.o
COBJS_LINKS	= stubs.o
AOBJS		= 
AOBJS_LINKS	= 

OBJS	:= $(addprefix $(obj),$(COBJS) $(COBJS_LINKS) $(AOBJS) $(AOBJS_LINKS))
SRCS	:= $(COBJS:.o=.c) $(AOBJS:.o=.S) $(addprefix $(obj), $(COBJS_LINKS:.o:.c) $(AOBJS_LINKS:.o:.S))

CPPFLAGS += -I$(TOPDIR) -I$(TOPDIR)/board/ACube/common
CFLAGS   += -I$(TOPDIR)/board/ACube/common
AFLAGS   += -I$(TOPDIR)/board/ACube/common

DEPS = $(OBJTREE)/u-boot.bin $(OBJTREE)/tools/mkimage
ifneq ($(DEPS),$(wildcard $(DEPS)))
$(error "updater: Missing required objects, please run regular build first")
endif

all:	$(obj).depend $(PROG) $(IMAGE)

#########################################################################

$(obj)%.srec:	%.o $(LIB)
	$(LD) -g -Ttext $(LOAD_ADDR) -o $(<:.o=) -e $(<:.o=) $< $(LIB)
	$(OBJCOPY) -O srec $(<:.o=) $@

$(obj)%.o: %.c
	$(CC) $(CFLAGS) -c -o $@ $<

$(obj)%.o: %.S
	$(CC) $(AFLAGS) -c -o $@ $<

$(obj)stubs.o: $(obj)stubs.c
	$(CC) $(CFLAGS) -c -o $@ $<

$(obj)stubs.c:
	rm -f $(obj)stubs.c
	ln -s $(SRCTREE)/examples/standalone/stubs.c $(obj)stubs.c

#########################################################################

$(obj)updater: $(OBJS)
	$(LD) -g -Ttext $(LOAD_ADDR) -o $(obj)updater -e _main $(OBJS) -L/opt/eldk-5.6/powerpc-4xx/sysroots/ppc440e-linux/usr/lib/powerpc-linux/4.8.2 -lgcc
	$(OBJCOPY) -O binary $(obj)updater $(obj)updater.bin

$(obj)updater.image: $(obj)updater $(OBJTREE)/u-boot.bin
	cat >/tmp/tempimage $(obj)updater.bin junk $(OBJTREE)/u-boot.bin
	$(OBJTREE)/tools/mkimage -A ppc -O u-boot -T standalone -C none -a $(LOAD_ADDR) \
	-e `$(NM) $(obj)updater | grep _main | cut --bytes=1-8` \
	-n "Firmware Updater" -d /tmp/tempimage $(obj)updater.image
	rm /tmp/tempimage
	cp $(obj)updater.image /boot/u-boot/$(UPDATER_IMAGE)

#########################################################################

# defines $(obj).depend target
include $(SRCTREE)/rules.mk

sinclude $(obj).depend

#########################################################################

=== debian/rules ===
--- 
+++ 
@@ -24,6 +24,20 @@
 # https://issues.redhat.com/browse/RHEL-7385
 ifneq ($(DEB_HOST_ARCH),amd64)
   export DEB_BUILD_MAINT_OPTIONS += optimize=-lto
+endif
+
+ifeq ($(VENDOR),ubuntu)
+  # Because we can't B-D on qemu-system-data, we can't run the
+  # upstream tests either.
+  export DEB_BUILD_PROFILES += nocheck
+
+  # Enable upstream vDSO if the OR expands to a non-empty string, e.g.:
+  # - $DEB_HOST_ARCH != amd64, OR
+  # - $DEB_HOST_ARCH_VARIANT is set (non-emtpy, e.g. amd64v3)
+  # Those are the conditions where we only run the "binary-arch" build.
+  ifneq ($(or $(filter-out amd64,$(DEB_HOST_ARCH)),$(DEB_HOST_ARCH_VARIANT)),)
+    export DEB_BUILD_PROFILES += pkg.qemu.use-upstream-vdso
+  endif
 endif
 
 # get CFLAGS LDFLAGS etc (should come after DEB_*MAINT*)
@@ -51,8 +65,7 @@
 libdir = /usr/lib/${DEB_HOST_MULTIARCH}
 mandir = /usr/share/man
 man1dir = ${mandir}/man1
-# remove ipxe for forky, require ipxe-qemu >> 1.21.1+git20220113.fbbdc3926+dfsg-1~ :
-FIRMWAREPATH = /usr/share/qemu:/usr/share/seabios:/usr/lib/ipxe/qemu
+FIRMWAREPATH = /usr/share/qemu:/usr/share/seabios
 
 export cross_prefix_alpha = alpha-linux-gnu-
 export cross_prefix_aarch64 = aarch64-linux-gnu-
@@ -215,8 +228,3 @@
 
 ifeq ($(DEB_HOST_ARCH_OS),linux)
 
-ifeq (${VENDOR},ubuntu)
-ifneq ($(filter ${DEB_HOST_ARCH},amd64 i386),)
-# on ubuntu *-spice existed, may be used in libvirt xml and scripts - keep links for compatibility
-# The sunset for this will be when Ubuntu-Bionic goes out of support which is expected to happen in 2028
-	install -m0644 -p -t debian/qemu-system-x86/usr/bin debian/kvm-spice debian/qemu-system-x86_64-spice
